using System.Runtime.Serialization;

namespace CoreLibrary.Exceptions
{
    /// <summary>
    /// Exception levée lorsqu'un indice de jeton est invalide.
    /// </summary>
    [Serializable]
    public class IndiceCodeException : Exception
    {
        /// <summary>
        /// Initialise une nouvelle instance de la classe <see cref="IndiceCodeException"/>.
        /// </summary>
        /// <param name="indice">L'indice incorrect qui a été spécifié.</param>
        /// <param name="indiceMax">L'indice maximum permis.</param>
        private const string messageDefaut = "L'indice du jeton que vous essayez de récupérer est hors de la plage valide.";

        public IndiceCodeException() : base(messageDefaut)
        { }

        public IndiceCodeException(int indice, int indiceMax) :
            base($"Vous avez essayé de récupérer le jeton à la place {indice}, mais son indice doit être compris entre 0 et {indiceMax}.")
        { }

        public IndiceCodeException(string message) : base(message)
        { }

        public IndiceCodeException(string message, Exception exception) : base(message, exception)
        { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        protected IndiceCodeException(SerializationInfo info, StreamingContext contexte) : base(info, contexte) { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        public override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
        }
    }
}
